import * as RED from '../service';
import * as UIA from './uiActions';
import accountverificationservice from '../accountverificationservice';
import { Actions } from 'react-native-router-flux';
import locationservice from '../locationservice';
import userservice from '../userservice';
var ReactNative = require('react-native');

var {
    AsyncStorage
} = ReactNative;
var _s = RED.createRedService();

export const setBearerToken = (bearerToken) => {
    return (dispatch, getState) => {
        _s.setBearerAccessToken(bearerToken);
        dispatch(_setBearerToken(bearerToken));
    };
}
export const logout = (callback) => {
    return (dispatch, getState) => {
        locationservice.stop();

        return AsyncStorage.setItem('bearer-token', '').then(() => {
            return AsyncStorage.setItem(UIA.SIGNED_OUT, 'true');
        }).then(() => {
            if (callback)
                callback();
        });
    };
}
export const startLocationService = () => {
    return (dispatch, getState) => {
        return locationservice.start(dispatch, getState);
    }
}
export const LOGGING_IN_PROCESS = 'LOGGING_IN_PROCESS';
export const loginProcess = (bearerToken, onloginfail, onsuccess) => {
    return (dispatch, getState) => {
        if (bearerToken && !UIA.IsBusy(getState(), [LOGGING_IN_PROCESS])) {
            dispatch(UIA.UI(LOGGING_IN_PROCESS, true));
            dispatch(UIA.UI(UIA.BEARER_TOKEN, bearerToken));
            _s.setBearerAccessToken(bearerToken);
            dispatch(_setBearerToken(bearerToken));
            var uniqueMachineSig = UIA.Get(getState(), UIA.UNIQUE_MACHINE_SIG);
            AsyncStorage.setItem(UIA.SIGNED_OUT, 'false');
            AsyncStorage.setItem('bearer-token', bearerToken);
            locationservice.start(dispatch, getState);
            if (onsuccess) {
                onsuccess();
            }
        }
    }
}

export const IS_PENDING_IDENTITY_CONFIRMATION = 'IS_PENDING_IDENTITY_CONFIRMATION';
export const IS_CUSTOMER = 'IS_CUSTOMER';
export const IS_VERIFIED = 'IS_VERIFIED';
function _setIsCustomer(isCustomer) {
    return {
        type: IS_CUSTOMER,
        isCustomer
    }
}

export const AUTH_REDUCER = "authReducer";
export const SET_BEARER_TOKEN = 'SET_BEARER_TOKEN';
function _setBearerToken(bearerToken) {
    return {
        type: SET_BEARER_TOKEN,
        bearerToken,
        store: AUTH_REDUCER
    }
}