import * as RED from './service';
import { parameters } from './endPoints';
const endpoints = {
    getAllManufactures: 'api/vehicles/getallmanufacturers',
    getModels: 'api/vehicles/getmakeformanufacturer',
    getMakesForManufacturesAndYear: 'api/vehicles/GetMakesForManufacturerAndYear',
    getmodelsformake: 'api/vehicles/getmodelsformake',
    //https://vpic.nhtsa.dot.gov/api/vehicles/GetModelsForMakeIdYear/makeId/474/modelyear/2015?format=json
    getModelsForMakeIdYear: 'api/vehicles/GetModelsForMakeIdYear',
    getMakes: 'api/vehicles/getallmakes',
    // https://vpic.nhtsa.dot.gov/api/vehicles/decodevinextended/1D7HA16D54J198791?format=json&modelyear=2011
    getVin: 'api/vehicles/decodevinextended'
}
var formatjson = '?format=json';
var carservice = RED.createRedService('https://vpic.nhtsa.dot.gov/', null, true);

export default {
    getManufacters: async () => {
        UIA.log('getting manufactures');
        return carservice.get(endpoints.getAllManufactures + formatjson);
    },
    getModels: async (maker) => {
        return carservice.get(endpoints.getModels + parameters(maker) + formatjson);
    },
    getMakes: async (maker, year) => {
        return carservice.get(endpoints.getMakesForManufacturesAndYear + parameters(maker) + formatjson + '&' + year);
    },
    getModelsForMake: async (maker) => {
        return carservice.get(endpoints.getmodelsformake + parameters(maker) + formatjson);
    },
    getModelsForMakeIdYear: async (makeId, year) => {
        return carservice.get(endpoints.getModelsForMakeIdYear + parameters('makeId', makeId, 'modelyear', year) + formatjson);
    },
    getAllMakes: async () => {
        return carservice.get(endpoints.getMakes + formatjson);
    },
    getVin: async (vin) => {
        return carservice.get(`${endpoints.getVin}/${vin}?format=json`)
    }
};